//
//  swiftmrb.c
//  swiftmrb
//
//  Created by Ryuji Watanabe on 2014/09/14.
//  Copyright (c) 2014年 Ryuji Watanabe. All rights reserved.
//

#include "mruby.h"
#include "proc.h"
#include "compile.h"
#include "dump.h"
#include "variable.h"
#include "string.h"

static mrb_state *mrb = NULL;
static mrbc_context *cxt = NULL;

/**
 open
 */
void* swift_mrb_open() {
	if (mrb == NULL) {
		mrb = mrb_open();
		cxt = mrbc_context_new(mrb);
	}
	return (void *)mrb;
}

/**
 close
 */
void swift_mrb_close() {
	if (mrb == NULL) {
		return;
	}
	mrbc_context_free(mrb, cxt);
	mrb_close(mrb);
	cxt = NULL;
	mrb = NULL;
}

/**
 mrubyコマンドを実行
 */
void swift_mrb_run(const char* code) {
	mrb_load_string_cxt(mrb, code, cxt);
}

/**
 mrbファイルを実行
 */
void swift_mrb_load_run(const char* fileName) {
	FILE *fp = fopen(fileName, "r");
	if (fp != NULL) {
		mrb_load_irep_file_cxt(mrb, fp, cxt);
	}
	fclose(fp);
}

/**
 グローバル変数の値を取得する
 */
void swift_mrb_gv_get(const char *valueName) {
	mrb_value value = mrb_load_string_cxt(mrb, valueName, cxt);
	char *hoge = RSTRING_PTR(value);
	printf("%s\n",hoge);
}

/**
 p
 */
void swift_mrb_p(const char* text) {
	mrb_value mvalue = mrb_str_new_cstr(mrb, text);
	mrb_p(mrb, mvalue);
}
